/**
 * Hamburg University of Technology
 * Institute of Telematics
 *
 *  Created on: Sep 19, 2013
 *      Author: homac
 */

#ifndef HIDDEN_H_
#define HIDDEN_H_

#include "origmm.h"


extern __thread int module_ignore;



static inline
void* hidden_malloc (size_t size) {
	void* ptr = NULL;
	if (orig_malloc) {
		module_ignore++;
		ptr = orig_malloc(size);
		module_ignore--;

	}
	return ptr;
}


static inline
void hidden_free (void* ptr) {
	if (orig_free) {
		module_ignore++;
		orig_free(ptr);
		module_ignore--;
	}
}
static inline
void hidden_free_mp (void *ptr, size_t size) {
	hidden_free(ptr);
}


static inline
void* hidden_calloc (size_t num, size_t elems) {
	void* ptr = NULL;
	if (orig_calloc) {
		module_ignore++;
		ptr = orig_calloc(num, elems);
		module_ignore--;
	}
	return ptr;
}

static inline
void* hidden_realloc (void *ptr, size_t size) {
	void* nptr = NULL;
	if (orig_realloc) {
		module_ignore++;
		nptr = orig_realloc(ptr, size);
		module_ignore--;
	}
	return nptr;
}

static inline
void * hidden_realloc_mp (void *ptr, size_t old_size, size_t new_size) {
	return hidden_realloc(ptr, new_size);
}


#endif /* HIDDEN_H_ */
