/**
 * Hamburg University of Technology
 * Institute of Telematics
 *
 *  Created on: Apr 19, 2013
 *      Author: homac
 */


#include "log.h"

#include <stdlib.h>
#include <assert.h>
#include <stdio.h>
#include <gmp.h>

#include "config.h"



static FILE* logout = 0;



int log_init(const char* file) {
	if (logout == 0) {
		logout = fopen(file, "w");
	}

	if (!logout) {
		logout = stderr;
		return -1;
	} else {

		return 0;
	}
}

void log_fini (void) {
	if (logout) {
		log_flush();
		logout = 0;
	}
}

void log_flush(void) {
	fflush(logout);
}

void log_error(const char* fmt, ...) {
	va_list ap;
	va_start(ap, fmt);
	int ret;
	log_printf("error: ");
	ret = gmp_vfprintf(logout, fmt, ap);
	assert(ret>=0);
	log_printf("\n");
	va_end(ap);
	log_flush();
	perror("system");
	abort();
}

void log_warning(const char* fmt, ...) {
	va_list ap;
	va_start(ap, fmt);
	int ret;
	log_printf("warning: ");
	ret = gmp_vfprintf(logout, fmt, ap);
	assert(ret>=0);
	log_printf("\n");
	log_flush();
	va_end(ap);
}

void log_info(const char* fmt, ...) {
	va_list ap;
	va_start(ap, fmt);
	if (output_humanized) {
		int ret;
		log_printf("info: ");
		ret = gmp_vfprintf(logout, fmt, ap);
		log_printf("\n");
		log_flush();
		assert(ret>=0);
	}
	va_end(ap);
}
void log_printf(const char* fmt, ...) {
	va_list ap;
	va_start(ap, fmt);
	int ret;
	ret = gmp_vfprintf(logout, fmt, ap);
	assert(ret>=0);
	log_flush();
	va_end(ap);
}
