/**
 * Hamburg University of Technology
 * Institute of Telematics
 *
 *  Created on: Apr 16, 2013
 *      Author: homac
 *
 * This header contains the pointers to the original functions
 * (malloc...) in the libc. Those are available after library
 * initialization (see mmprof).
 */

#ifndef SRC_ORIGMM_H_
#define SRC_ORIGMM_H_
#include <stdlib.h>




extern
void* (*orig_malloc) 	(size_t size);

extern
void  (*orig_free)   	(void* ptr);

extern
void* (*orig_calloc) 	(size_t num, size_t elems);

extern
void* (*orig_realloc)	(void *ptr, size_t size);



void origmm_init(const char* library_name,
		const char* library_malloc_name,
		const char* library_calloc_name,
		const char* library_realloc_name,
		const char* library_free_name);

static inline
void * orig_realloc_mp (void *ptr, size_t old_size, size_t new_size) {
	return orig_realloc(ptr, new_size);
}
static inline
void orig_free_mp (void *ptr, size_t size) {
	orig_free(ptr);
}


#endif /* SRC_ORIGMM_H_ */
