/**
 * Hamburg University of Technology
 * Institute of Telematics
 *
 *  Created on: Apr 15, 2013
 *      Author: homac
 */

#include <malloc.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>


void error_exit(char* msg) {
	perror(msg);
	exit(-1);
}


void malloc_info_stats (void) {
	struct mallinfo info = mallinfo();
#define PRINTMEMBER(format, obj, member) printf( #member ": " format "\n", obj.member);

	PRINTMEMBER("%d", info, arena);
	PRINTMEMBER("%d", info, ordblks);
	PRINTMEMBER("%d", info, smblks);
	PRINTMEMBER("%d", info, hblks);
	PRINTMEMBER("%d", info, hblkhd);
	PRINTMEMBER("%d", info, usmblks);
	PRINTMEMBER("%d", info, fsmblks);
	PRINTMEMBER("%d", info, uordblks);
	PRINTMEMBER("%d", info, fordblks);
	PRINTMEMBER("%d", info, keepcost);

	malloc_stats();
}

void* start_routine (void * args) {
	void* ptr = malloc(10);


	free(ptr);
	return NULL;
}




int main (int argc, char** argv) {
	pthread_t thread;
	pthread_attr_t attr;
    void* ret;

    if (0!=pthread_attr_init(&attr))
    	error_exit("pthread_attr_init");

    if (0!=pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_JOINABLE))
    	error_exit("pthread_attr_setdetachstate");

    if (0!=pthread_create(&thread, &attr, start_routine, NULL))
		error_exit("pthread_create");


    start_routine(NULL);

    if (0!=pthread_join(thread, &ret))
		error_exit("pthread_join");

	return 0;
}

